<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2014 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2014-02-11 18:01:31Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Fri, 23 Sep 2011 10:20:53 +0300
 * 
 * @method Carerix_Api_Rest_Entity_CREmployee setAdditionalInfo()
 * setAdditionalInfo(Carerix_Api_Rest_DataType_NSDictionary|array $value) Set
 * additionalInfo attribute. Provides a fluent interface.
 * @method Carerix_Api_Rest_DataType_NSDictionary|array getAdditionalInfo
 * getAdditionalInfo() Get additionalInfo attribute.
 */
class Carerix_Api_Rest_Entity_CREmployee extends Carerix_Api_Rest_Entity_Abstract_CREmployee
{
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 255
     */
    public $fullAddress = null;
    
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 40
     */
    public $city = null;
    
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 200
     * @alias toUser.emailAddresses[0].emailAddress
     */
    public $emailAddress = null;
    
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 200
     * @alias toUser.emailAddresses[0].emailAddress
     */
    public $emailAddressBusiness = null;
    
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 40
     */
    public $phoneNumberBusiness = null;
    
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 40
     */
    public $phoneNumber = null;
    
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 40
     */
    public $mobileNumber;
    
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 40
     */
    public $mobileNumberBusiness;
    
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 40
     */
    public $firstName = null;
    
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 60
     */
    public $lastName = null;
    
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 40
     */
    public $lastNamePrefix = null;
       
    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toCountryNode
     * @qualifier ((typeID = 11) or (typeID = 0))
     * @default 1
     * @nodeType Land
     */
    public $toCountryNode = null;
        
    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toGenderNode
     * @qualifier 
     * @default 
     * @nodeType 
     */
    public $toGenderNode = null;
    
    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toStatusNode
     * @default
     * @nodeType Kandidaat-status
     */
    public $toStatusNode = null;
         
    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toPovinceNode
     */
    public $toPovinceNode = null;
    
    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toProductTypeNode1
     */
    public $toProductTypeNode1 = null;
    
    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toProductTypeNode2
     * 
     */
    public $toProductTypeNode2 = null;
    
    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toProductTypeNode3
     */
    public $toProductTypeNode3 = null;
    
    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toMinSalaryPeriodNode
     */
    public $toMinSalaryPeriodNode = null;
    
    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Entity_CRUser
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRUser")
     * @mandatory 0
     * @destination_entity CRUser
     * @to_many 0
     * @name owner
     */
    public $owner = null;
         
    /**
     * ATTENTION: Does not work for save operation!!!
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 1
     * @name groups
     * @nodeType Groep-Kandidaat
     */
    public $groups = null;
    
    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 1
     * @name groupNodes
     * @nodeType Groep-Kandidaat
     */
    private $groupNodes = null;
    

    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CREmailAddress")
     * @mandatory 0
     * @destination_entity CREmailAddress
     * @to_many 1
     * @name emailAddresses
     */
    public $emailAddresses = null;
    
   /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 32
     */
    public $suffix = null;
    
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 32
     */
    public $title = null;
    
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSCalendarDate
     * @allows_null 1
     */
    public $birthDate = null;
    
    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 10
     */
    public $homeNumber = null;

    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 10
     */
    public $homeNumberSuffix = null;

    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 30
     */
    public $homePostalCode = null;

    /**
     * @cx_field true
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 60
     */
    public $homeStreet = null;
    
    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toHomeCountryNode
     * @qualifier
     * @default
     * @nodeType
     */
    public $toHomeCountryNode = null;
    
    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toHomeProvinceNode
     * @qualifier
     * @default
     * @nodeType
     */
    public $toHomeProvinceNode = null;

    /**
     * @cx_field true
     * @access private
     * @var Carerix_Api_Rest_DataType_NSDictionary|array
     * @value_class NSDictionary
     * @allows_null 1
     * @backend v49
     */
    public $additionalInfo = null;
    
    /**
     * Set groupNodes.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CREmployee
     */
    public function setGroupNodes($values)
    {
        $this->toUser = (is_null($this->toUser))? new Carerix_Api_Rest_Entity_CRUser(): $this->toUser;
        $this->toUser->setGroupNodes($values);
        return $this;
    }
    
    /**
     * Get groupNodes.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getGroupNodes($index = null)
    {
        if (!is_null($this->toUser)) {
            return $this->toUser->getGroupNodes($index);
        }
    }
    
    /**
     * Set groups.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CREmployee
     */
    public function setGroups($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRDataNode');
        }
        $this->groups = $values;
        return $this;
    }
    
    /**
     * Get groups.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getGroups($index = null)
    {
        if($index !== null) {
            return $this->groups[$index];
        }
        return $this->groups;
    }
    
    /**
     * Set toMinSalaryPeriodNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return self
     */
    public function setToMinSalaryPeriodNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value);
        }
        $this->toMinSalaryPeriodNode = $value;
        return $this;
    }
    
    /**
     * Get toMinSalaryPeriodNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToMinSalaryPeriodNode()
    {
        return $this->toMinSalaryPeriodNode;
    }
    
    /**
     * Set toProductTypeNode3.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return self
     */
    public function setToProductTypeNode3($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value);
        }
        $this->toProductTypeNode3 = $value;
        return $this;
    }
    
    /**
     * Get toProductTypeNode3.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToProductTypeNode3()
    {
        return $this->toProductTypeNode3;
    }
    
    /**
     * Set toProductTypeNode2.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return self
     */
    public function setToProductTypeNode2($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value);
        }
        $this->toProductTypeNode2 = $value;
        return $this;
    }
    
    /**
     * Get toProductTypeNode2.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToProductTypeNode2()
    {
        return $this->toProductTypeNode2;
    }
    
    /**
     * Set toProductTypeNode1.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return self
     */
    public function setToProductTypeNode1($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value);
        }
        $this->toProductTypeNode1 = $value;
        return $this;
    }
    
    /**
     * Get toProductTypeNode1.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToProductTypeNode1()
    {
        return $this->toProductTypeNode1;
    }
    
    /**
     * Set toPovinceNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return self
     */
    public function setToPovinceNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value);
        }
        $this->toPovinceNode = $value;
        return $this;
    }
    
    /**
     * Get toPovinceNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToPovinceNode()
    {
        return $this->toPovinceNode;
    }
   
     
    /**
     * Gets toHomeProvinceNode
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToHomeProvinceNode() 
    {
        return $this->toHomeProvinceNode;
    }
    
    /**
     * Sets toHomeProvinceNode
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $toHomeProvinceNode $value
     * @return self
     */
    public function setToHomeProvinceNode($value) 
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value);
        }
        $this->toHomeProvinceNode = $value;
        return $this;
    }
    
    /**
     * Gets toHomeCountryNode
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToHomeCountryNode() 
    {
        return $this->toHomeCountryNode;
    }
    
    /**
     * Sets toHomeCountryNode
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $toHomeCountryNode $value
     * @return self
     */
    public function setToHomeCountryNode($value) 
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value);
        }
        $this->toHomeCountryNode = $value;
        return $this;
    }
    
    /**
     * Gets homePostalCode
     *
     * @return string
     */
    public function getHomePostalCode()
    {
        return $this->homePostalCode;
    }
    
    /**
     * Sets homePostalCode
     *
     * @param string $homePostalCode homePostalCode
     * @return self
     */
    public function setHomePostalCode($homePostalCode) 
    {
        $this->homePostalCode = $homePostalCode;
        return $this;
    }
    
    /**
     * Gets homeNumberSuffix
     *
     * @return string
     */
    public function getHomeNumberSuffix()
    {
        return $this->homeNumberSuffix;
    }
    
    /**
     * Sets homeNumberSuffix
     *
     * @param string $homeNumberSuffix homeNumberSuffix
     * @return self
     */
    public function setHomeNumberSuffix($homeNumberSuffix) 
    {
        $this->homeNumberSuffix = $homeNumberSuffix;
        return $this;
    }
    
    /**
     * Gets homeNumber
     *
     * @return string
     */
    public function getHomeHomeNumber()
    {
        return $this->homeNumber;
    }
    
    /**
     * Sets homeNumber
     *
     * @param string $homeNumber homeNumber
     * @return self
     */
    public function setHomeNumber($homeNumber) 
    {
        $this->homeNumber = $homeNumber;
        return $this;
    }
    
    /**
     * Gets homeStreet
     *
     * @return string
     */
    public function getHomeStreet()
    {
        return $this->homeStreet;
    }
    
    /**
     * Sets homeStreet
     *
     * @param string $homeStreet homeStreet
     * @return self
     */
    public function setHomeStreet($homeStreet) 
    {
        $this->homeStreet = $homeStreet;
        return $this;
    }
    
    /**
     * Gets birthDate
     *
     * @return string
     */
    public function getBirthDate()
    {
        return $this->birthDate;
    }
    
    /**
     * Sets birthDate
     *
     * @param string $birthDate birthDate
     * @return self
     */
    public function setBirthDate($birthDate) 
    {
        $this->birthDate = $birthDate;
        return $this;
    }
    
    /**
     * Gets suffix
     *
     * @return string
     */
    public function getSuffix() 
    {
        return $this->suffix;
    }
    
    /**
     * Sets suffix
     *
     * @param string $suffix suffix
     * @return self
     */
    public function setSuffix($suffix) 
    {
        $this->suffix = $suffix;
        return $this;
    }
    
    /**
     * Gets title
     *
     * @return string
     */
    public function getTitle() 
    {
        return $this->title;
    }
    
    /**
     * Sets title
     *
     * @param string $title title
     * @return self
     */
    public function setTitle($title) 
    {
        $this->title = $title;
        return $this;
    }
    
    /**
     * initials
     * @access private
     * @var string
     */
    public $initials;
    
    /**
     * Gets initials
     *
     * @return string
     */
    public function getInitials() 
    {
        return $this->initials;
    }
    
    /**
     * Sets initials
     *
     * @param string $initials initials
     * @return self
     */
    public function setInitials($initials) 
    {
        $this->initials = $initials;
        return $this;
    }
    
    /**
     * Set emailAddresses
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_CREmailAddress
     */
    public function setEmailAddresses($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CREmailAddress'); 
        } 
        $this->emailAddresses = $values;
        return $this;
    }

    /**
     * Get emailAddresses.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CREmailAddress
     */
    public function getEmailAddresses($index = null)
    {
        if($index !== null) {
            return $this->emailAddresses[$index];
        }
        return $this->emailAddresses;
    }
         
    /**
     * Gets fullAddress
     *
     * @return string
     */
    public function getFullAddress() 
    {
        return $this->fullAddress;
    }
    
    /**
     * Sets fullAddress
     *
     * @param string $fullAddress fullAddress
     * @return self
     */
    public function setFullAddress($fullAddress) 
    {
        $this->fullAddress = $fullAddress;
        return $this;
    }
    
    /**
     * Gets city
     *
     * @return string
     */
    public function getCity() 
    {
        return $this->city;
    }
    
    /**
     * Sets city
     *
     * @param string $city city
     * @return self
     */
    public function setCity($city) 
    {
        $this->city = $city;
        return $this;
    }    
            
    /**
     * Gets emailAddress
     *
     * @return string
     */
    public function getEmailAddress() 
    {
        return $this->emailAddress;
    }
    
    /**
     * Sets emailAddress
     *
     * @param string $emailAddress emailAddress
     * @return self
     */
    public function setEmailAddress($emailAddress) 
    {
        $this->emailAddress = $emailAddress;
        return $this;
    }
        
    /**
     * Gets emailAddressBusiness
     *
     * @return string
     */
    public function getEmailAddressBusiness() 
    {
        return $this->emailAddressBusiness;
    }
    
    /**
     * Sets emailAddressBusiness
     *
     * @param string $emailAddressBusiness emailAddressBusiness
     * @return self
     */
    public function setEmailAddressBusiness($emailAddressBusiness) 
    {
        $this->emailAddressBusiness = $emailAddressBusiness;
        return $this;
    }
        
    /**
     * Gets phoneNumberBusiness
     *
     * @return string
     */
    public function getPhoneNumberBusiness() 
    {
        return $this->phoneNumberBusiness;
    }
    
    /**
     * Sets phoneNumberBusiness
     *
     * @param string $phoneNumberBusiness phoneNumberBusiness
     * @return self
     */
    public function setPhoneNumberBusiness($phoneNumberBusiness) 
    {
        $this->phoneNumberBusiness = $phoneNumberBusiness;
        return $this;
    }
        
    /**
     * Gets phoneNumber
     *
     * @return string
     */
    public function getPhoneNumber() 
    {
        return $this->phoneNumber;
    }
    
    /**
     * Sets phoneNumber
     *
     * @param string $phoneNumber phoneNumber
     * @return self
     */
    public function setPhoneNumber($phoneNumber) 
    {
        $this->phoneNumber = $phoneNumber;
        return $this;
    }
        
    /**
     * Gets mobileNumber
     *
     * @return string
     */
    public function getMobileNumber() 
    {
        return $this->mobileNumber;
    }
    
    /**
     * Sets mobileNumber
     *
     * @param string $mobileNumber mobileNumber
     * @return self
     */
    public function setMobileNumber($mobileNumber) 
    {
        $this->mobileNumber = $mobileNumber;
        return $this;
    }
        
    /**
     * Gets mobileNumberBusiness
     *
     * @return string
     */
    public function getMobileNumberBusiness() 
    {
        return $this->mobileNumberBusiness;
    }
    
    /**
     * Sets mobileNumberBusiness
     *
     * @param string $mobileNumberBusiness mobileNumberBusiness
     * @return self
     */
    public function setMobileNumberBusiness($mobileNumberBusiness) 
    {
        $this->mobileNumberBusiness = $mobileNumberBusiness;
        return $this;
    }
        
    /**
     * Gets firstName
     *
     * @return string
     */
    public function getFirstName() 
    {
        return $this->firstName;
    }
    
    /**
     * Sets firstName
     *
     * @param string $firstName firstName
     * @return self
     */
    public function setFirstName($firstName) 
    {
        $this->firstName = $firstName;
        return $this;
    }
    
    /**
     * Gets lastName
     *
     * @return string
     */
    public function getLastName() 
    {
        return $this->lastName;
    }
    
    /**
     * Sets lastName
     *
     * @param string $lastName lastName
     * @return self
     */
    public function setLastName($lastName) 
    {
        $this->lastName = $lastName;
        return $this;
    }
    
    /**
     * Gets lastNamePrefix
     *
     * @return string
     */
    public function getLastNamePrefix() 
    {
        return $this->lastNamePrefix;
    }
    
    /**
     * Sets lastNamePrefix
     *
     * @param string $lastNamePrefix lastNamePrefix
     * @return self
     */
    public function setLastNamePrefix($lastNamePrefix) 
    {
        $this->lastNamePrefix = $lastNamePrefix;
        return $this;
    }
        
    /**
     * Gets toCountryNode
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToCountryNode() 
    {
        return $this->toCountryNode;
    }
    
    /**
     * Sets toCountryNode
     *
     * @param Carerix_Api_Rest_Entity_CRDataNode $toCountryNode toCountryNode
     * @return self
     */
    public function setToCountryNode($toCountryNode) 
    {
        $this->toCountryNode = $toCountryNode;
        return $this;
    }
        
    /**
     * Gets toGenderNode
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToGenderNode() 
    {
        return $this->toGenderNode;
    }
    
    /**
     * Sets toGenderNode
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $toGenderNode $value
     * @return self
     */
    public function setToGenderNode($value) 
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value);
        }
        $this->toGenderNode = $value;
        return $this;
    }
       
    /**
     * Set toStatusNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_Employee
     */
    public function setToStatusNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toStatusNode = $value;
        return $this;
    }

    /**
     * Get toStatusNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToStatusNode()
    {
        return $this->toStatusNode;
    }
    
    /**
     * Get owner.
     *
     * @return Carerix_Api_Rest_Entity_CRUser
     */
    public function getOwner()
    {
        return $this->owner;
    }
    
    /**
     * Set owner.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRUser $value
     * @return Carerix_Api_Rest_Entity_CRUser
     */
    public function setOwner($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRUser($value);
        }
        $this->owner = $value;
        return $this;
    }
    
    /**
     * alias for _todos setter
     */
    public function setTodos($values)
    {
        return $this->set_todos($values);
    }
    
    /**
     * alias for _todos getter
     */
    public function getTodos()
    {
        return $this->get_todos();
    }
        
    /**
     * Get employee by username and password
     * 
     * @param array $parameters 
     * @return Carerix_Api_Rest_Entity_Employee
     * 
     * @see http://development.wiki.carerix.com/index.php/Cxrest_API_methods#GET_employee.2Fget-by
     * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
     */    
    public static function getBy(array $parameters)
    {
        $action = 'get-by';
        $get_called_class = get_called_class();
        return self::$_manager->execute(
            $get_called_class,
            self::generateUrl(get_defined_vars(), $get_called_class),
            Carerix_Api_Rest_Client::GET,
            $parameters
        );
    }
    
    /**
     * Create or modify an employee object and perform additional tasks in one go. 
     * 
     * @param array $parameters [optional]
     * @return Carerix_Api_Rest_Entity_Employee
     * 
     * @see http://development.wiki.carerix.com/index.php/Cxrest_API_methods#POST_employee.2Fapply
     * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
     */        
    public function apply($parameters = null)
    {
        $method = $this->exists() ? 'put' : 'post';
        return $this->$method('apply', $parameters);
    }
    
    /**
     * (non-PHPdoc)
     * @see Carerix_Api_Rest_Entity::subscribe()
     * @return Carerix_Api_Rest_Entity_Employee
     */
    public function subscribe()
    {
        $args = func_get_args();
        return call_user_func_array(array('parent', 'subscribe'), $args);    
    }

}